/*
    Copyright (C) 2001 by Jorrit Tyberghein

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "cssysdef.h"

#include "simple2.h"

CS_IMPLEMENT_APPLICATION

//-----------------------------------------------------------------------------

int i=1;
Simple::Simple ()
{
  SetApplicationName ("CrystalSpace.Simple2");

}

Simple::~Simple ()
{
}

csTicks startTime = 0;
csTicks occasionTime = 10000;
csTicks lastTime = occasionTime*-1;
int lastAgentCommandTime = 0;
int backLastAgentCommandTime=0;
void Simple::printPictureOccasionally (csTicks time) {
  if ((lastTime+occasionTime)<time)
    {
    printPicture(time);
    }
}

void Simple::printPicture (csTicks time) {
  //initialize clock
  if (startTime == 0) startTime = time;

  iGraphics2D* g2d = g3d->GetDriver2D();
  csRef<iImage> img;
  csRef<iImageIO> imgio;
  csRef<iDataBuffer> data;
  csRef<iVFS> vfs;
  //this was 14 with no crashing, but crashed when I got over
  //10 screens. It actually has 16 chars, so 18 sorts the problem
  //but will probably fail when we get above 1000.
  char str[18];
  static short int num = 0;       
        
  imgio = CS_QUERY_REGISTRY(GetObjectRegistry(), iImageIO);
  vfs = CS_QUERY_REGISTRY(GetObjectRegistry(), iVFS);
        
  agentView->Draw();
  //grab the screenshot as a databuffer
  img = g2d->ScreenShot();       
         
  data = imgio->Save(img, "image/jpg");
  //remember to use the vfs mechanism via vfs.cfg
  //if  (!vfs->ChDir("/this/"))
  if  (!vfs->ChDir("/cantAgent/"))
    {
    ReportError("Could not set directory!");
    return;
    }       

  userView->Draw();

  //it was quite a hassle to get the file working.  
  //I found the picture stuff on the net (search for screenshot in 
  //sourceforge's developers forum.
  //I found
  //if  (vfs->Exists("VFS.Mount.this"))
  //  csRef<iStringArray> mounts = vfs->GetMounts();
  //helped slog through it. CH

  sprintf(str, "screenshot%d.jpg", num);
  //sprintf(str, "screenshot.png");
        
  //Write the data to a file...`
  //csRef<iFile> temp = vfs->Open("bob.txt", VFS_FILE_WRITE);
  if(!vfs->WriteFile(str, data->GetData(), data->GetSize()))
    {
    ReportError("Could not save screenshot!");
    return;
    }       
  
  //write command file to CANT23Agent
  lastTime = time;
  scfString textOutput;
  char timeStr[20];
  textOutput.Append("start time ");
  sprintf(timeStr, "%d\n", startTime);
  textOutput.Append(timeStr);
  textOutput.Append("current time ");
  sprintf(timeStr, "%d\n", time);
  textOutput.Append(timeStr);
  sprintf(timeStr, "screenshot%d.jpg", num++);
  textOutput.Append(timeStr);
  if(!vfs->WriteFile("csToCABotPicture.txt", textOutput.GetData(), textOutput.Length()))
    {
    ReportError("Could not write command!");
    return;
    }       
}

//----keyboard handler stuff
scfString userCommand;
void Simple::addKeyToCommand (char keyDown) {
  //undone this won't handle the user typing a key multiple times.
  //you have to catch the empty key state to do this.
  static char lastKey = ' ';
  
  if (keyDown == lastKey) return;

  lastKey = keyDown;
  userCommand.Append(lastKey);
}

void Simple::sendAgentCommandToCANT () {
  //get the directory
  csRef<iVFS> vfs;
  vfs = CS_QUERY_REGISTRY(GetObjectRegistry(), iVFS);
        
  //remember to use the vfs mechanism via vfs.cfg
  //if  (!vfs->ChDir("/this/"))
  if  (!vfs->ChDir("/cantAgent/"))
    {
    ReportError("Could not set directory!");
    return;
    }       

  //write the text to the file
  lastTime = vc->GetCurrentTicks ();
  scfString textOutput;
  char timeStr[20];
  textOutput.Append("start time ");
  sprintf(timeStr, "%d\n", startTime);
  textOutput.Append(timeStr);
  textOutput.Append("current time ");
  sprintf(timeStr, "%d\n", lastTime);
  textOutput.Append(timeStr);
  textOutput.Append(userCommand);
  if(!vfs->WriteFile("csToCABotText.txt", textOutput.GetData(), textOutput.Length()))
    {
    ReportError("Could not write text command!");
    return;
    }       
  if  (!vfs->Sync())
    {
    ReportError("Could not sync after write to CANT!");
    return;
    }       

}

int Simple::processAgentCommand() {
  csRef<iVFS> vfs;
  csRef<iDataBuffer> agentData;

  vfs = CS_QUERY_REGISTRY(GetObjectRegistry(), iVFS);
        
  //remember to use the vfs mechanism via vfs.cfg
  if  (!vfs->ChDir("/cantAgent/"))
    {
    ReportError("Could not set directory!");
    return(0);
    }       

  agentData = vfs->ReadFile("cABotToCSCommand.txt", 1);
  //has this opened correctly?
  if (!agentData.IsValid())
    {
    //ReportError("Could not read  to agent file; probably not closed!");
    return(0);
    }       

  if  (!vfs->Sync())
    {
    ReportError("Could not sync after agent read!");
    return(0);
    }       


  //get the time and if time is less than or equal to the last
  //processed time return 0 to ignore
  char * text=new char(100);
  text = agentData->GetData();

  char c1,c2,c3,c4,c5,c6;
  int timeOfCommand;
  char* command = new char(10);
  sscanf(text,"%c%c%c%c%c%c%d%s",&c1,&c2,&c3,&c4,&c5,&c6,&timeOfCommand,command);

  //delete []text;

  if (timeOfCommand <= lastAgentCommandTime)
    {
      //delete []command;
    return(0);
    }
 
  //ReportError(text);

  backLastAgentCommandTime=lastAgentCommandTime;
  lastAgentCommandTime=timeOfCommand;

  if (strcmp(command,"Left") == 0) {
    //ReportError("GoLeft");
    return (1);
  }
  else if (strcmp(command,"Right") == 0) {
    //ReportError("GoRight");
    return (2);
  }
  else if (strcmp(command,"Forward") == 0) {
    //ReportError("Go Forward");
    return (3);
  }
  else if (strcmp(command,"Back") == 0) {
    //ReportError("GoBAck");
    return (4);
  }
  else if (strcmp(command,"Reset") == 0) {
    //ReportError("Reset");
    return (5);
  }
  else if (strcmp(command,"Reset2") == 0) {
    //ReportError("Reset");
    return (6);
  }
  //else ReportError(command);
  //  delete []command;
  
  return (-1);
}

void Simple::resetGame (int version) {
  int agentStartX = 21;
  int agentStartY = 15;
  int agentStartHeight = 3;

  if (version == 0)
    agentRotY = 4.45;
  else 
    agentRotY = 4.75;

  // Now we need to position the camera in our world.
  agentView->GetCamera ()->SetSector (room);
  agentView->GetCamera ()->GetTransform ().SetOrigin 
    (csVector3 (agentStartX, agentStartHeight, agentStartY));

  iCamera* agentCamera = agentView->GetCamera();
  csMatrix3 rot = csXRotMatrix3 (agentRotX) * csYRotMatrix3 (agentRotY);
  csOrthoTransform ot (rot, agentCamera->GetTransform().GetOrigin ());
  agentCamera->SetTransform (ot);
  agent->GetMovable()->SetTransform(ot);
  agent->GetMovable()->UpdateMove();
}

void Simple::moveAgent (int command) {
  iCamera* agentCamera = agentView->GetCamera();
  csVector3 agentChange;
  float speed = 0.05; 

  if (command == 1) //Left
    {
    //ReportError("Agent goes left");
      agentRotY -= speed ; //(speed*.95)
    }
  else if (command == 2) 
    {
    //ReportError("Agent goes right");
    agentRotY += speed;
    }
  else if (command == 3) 
    {
    //ReportError("Agent goes forward");
    agentCamera->Move (CS_VEC_FORWARD  );
    }
  else if (command == 4) 
    {
    //ReportError("Agent goes back");
    agentCamera->Move (CS_VEC_BACKWARD );
    }
  else if (command == 5) 
    {
    //ReportError("Agent goes back");
    resetGame(0);
    }
  else if (command == 6) 
    {
    //ReportError("Agent goes back");
    resetGame(1);
    }
  else return;

  //move camera
  csMatrix3 rot = csXRotMatrix3 (agentRotX) * csYRotMatrix3 (agentRotY);
  csOrthoTransform ot (rot, agentCamera->GetTransform().GetOrigin ());
  agentCamera->SetTransform (ot);
  agent->GetMovable()->SetTransform(ot);
  agent->GetMovable()->UpdateMove();

  printPicture(vc->GetCurrentTicks ());
}

void Simple::ProcessFrame ()
{
  // First get elapsed time from the virtual clock.
  csTicks elapsed_time = vc->GetElapsedTicks ();

  //--------CRH get agent commands
  //Check if there is a command from the agent and if so
  //do it.
  int agentCommand = processAgentCommand();

  if (agentCommand > 0) 
    moveAgent(agentCommand);
  else if (agentCommand != 0)
    {
    //ReportError("Bad Agent Command");
    //it seems that file io gets messed up occasionally,
    //and this kludge fixes it.
    lastAgentCommandTime=backLastAgentCommandTime;
    }

  printPictureOccasionally(vc->GetCurrentTicks ());
  //-------end CRH block

  //movement and camera for user
  gameView(elapsed_time);

  // Tell 3D driver we're going to display 3D things.
  if (!g3d->BeginDraw (engine->GetBeginDrawFlags () | CSDRAW_3DGRAPHICS))
    return;

  // Tell the camera to render into the frame buffer.
  if (kbd->GetKeyState (CSKEY_F2))
    agentView->Draw ();
  else {
    userView->Draw ();
  }
}

void Simple::gameView(float elapsed_time){
  //rotate the camera according to keyboard state
  float speed = (elapsed_time / 1000.0) * (0.06 * 20);

  iCamera* c = userView->GetCamera();

  // left and right cause the camera to rotate on the global Y
  // axis; page up and page down cause the camera to rotate on the
  // _camera's_ X axis (more on this in a second) and up and down
  // arrows cause the camera to go forwards and backwards.
  if (kbd->GetKeyState (CSKEY_RIGHT))
    userRotY += speed;
  if (kbd->GetKeyState (CSKEY_LEFT))
    userRotY -= speed;
  if (kbd->GetKeyState (CSKEY_UP))
    c->Move (CS_VEC_FORWARD * 4 * speed);
  if (kbd->GetKeyState (CSKEY_DOWN))
    c->Move (CS_VEC_BACKWARD * 4 * speed);
  if (kbd->GetKeyState (CSKEY_F3))
    {
    printPicture(vc->GetCurrentTicks ());
    userRotY -= speed;
    }

  //---stuff for the user to emit a command to the agent
  if (kbd->GetKeyState (CSKEY_ENTER))
    {
    ReportError(userCommand);
    sendAgentCommandToCANT();
    userCommand.Clear();
    }
  if (kbd->GetKeyState ('a'))	addKeyToCommand('a');
  if (kbd->GetKeyState ('b'))	addKeyToCommand('b');
  if (kbd->GetKeyState ('c'))	addKeyToCommand('c');
  if (kbd->GetKeyState ('d'))	addKeyToCommand('d');
  if (kbd->GetKeyState ('e'))	addKeyToCommand('e');
  if (kbd->GetKeyState ('f'))	addKeyToCommand('f');
  if (kbd->GetKeyState ('g'))	addKeyToCommand('g');
  if (kbd->GetKeyState ('h'))	addKeyToCommand('h');
  if (kbd->GetKeyState ('i'))	addKeyToCommand('i');
  if (kbd->GetKeyState ('j'))	addKeyToCommand('j');
  if (kbd->GetKeyState ('k'))	addKeyToCommand('k');
  if (kbd->GetKeyState ('l'))	addKeyToCommand('l');
  if (kbd->GetKeyState ('m'))	addKeyToCommand('m');
  if (kbd->GetKeyState ('n'))	addKeyToCommand('n');
  if (kbd->GetKeyState ('o'))	addKeyToCommand('o');
  if (kbd->GetKeyState ('p'))	addKeyToCommand('p');
  if (kbd->GetKeyState ('q'))	addKeyToCommand('q');
  if (kbd->GetKeyState ('r'))	addKeyToCommand('r');
  if (kbd->GetKeyState ('s'))	addKeyToCommand('s');
  if (kbd->GetKeyState ('t'))	addKeyToCommand('t');
  if (kbd->GetKeyState ('u'))	addKeyToCommand('u');
  if (kbd->GetKeyState ('v'))	addKeyToCommand('v');
  if (kbd->GetKeyState ('w'))	addKeyToCommand('w');
  if (kbd->GetKeyState ('x'))	addKeyToCommand('x');
  if (kbd->GetKeyState ('y'))	addKeyToCommand('y');
  if (kbd->GetKeyState ('z'))	addKeyToCommand('z');
  if (kbd->GetKeyState (CSKEY_SPACE))	addKeyToCommand(' ');
  if (kbd->GetKeyState ('.'))	addKeyToCommand('.');
  if (kbd->GetKeyState ('#'))
      {
  scfString textOutput;
  textOutput.Append("user camera ");
  char rotStr[20];
  sprintf(rotStr, "%f %f %f \n",c->GetTransform().GetOrigin ()[0],
	  c->GetTransform().GetOrigin ()[2],
          userRotY);
  textOutput.Append(rotStr);
  ReportError(textOutput);
      }
  if (kbd->GetKeyState ('='))
      {
  scfString textOutput;
  textOutput.Append("user sprite ");
  char rotStr[20];
  sprintf(rotStr, "%f %f \n",
    user->GetMovable()->GetTransform().GetOrigin ()[0],
    user->GetMovable()->GetTransform().GetOrigin ()[2]);
  textOutput.Append(rotStr);
  ReportError(textOutput);
      }
  if (kbd->GetKeyState (']'))
      {
  scfString textOutput;
  textOutput.Append("agent sprite ");
  char rotStr[20];
  sprintf(rotStr, "%f %f \n",
    agent->GetMovable()->GetTransform().GetOrigin ()[0],
    agent->GetMovable()->GetTransform().GetOrigin ()[2]);
  textOutput.Append(rotStr);
  ReportError(textOutput);
      }
  if (kbd->GetKeyState ('['))
      {
  iCamera* agentCamera = agentView->GetCamera();
  scfString textOutput;
  textOutput.Append("agent camera ");
  char rotStr[30];
  sprintf(rotStr, "%f %f %f \n",
    agentCamera->GetTransform().GetOrigin ()[0],
    agentCamera->GetTransform().GetOrigin ()[2],
    agentRotY);
  textOutput.Append(rotStr);
  ReportError(textOutput);
      }

  // We now assign a new rotation transformation to the camera.  You
  // can think of the rotation this way: starting from the zero
  // position, you first rotate "rotY" radians on your Y axis to get
  // the first rotation.  From there you rotate "rotX" radians on the
  // your X axis to get the final rotation.  We multiply the
  // individual rotations on each axis together to get a single
  // rotation matrix.  The rotations are applied in right to left
  // order .
  csMatrix3 rot = csXRotMatrix3 (userRotX) * csYRotMatrix3 (userRotY);
  csOrthoTransform ot (rot, c->GetTransform().GetOrigin ());
  c->SetTransform (ot);
  user->GetMovable()->SetTransform(ot);
  user->GetMovable()->UpdateMove();


}
void Simple::createUser() {
  moving = false;

  // Load a texture for our sprite.
  iTextureWrapper* txt = loader->LoadTexture ("green","/lib/std/spark.png");
  if (txt == 0)
    ReportError("Error loading texture!");

  // Load a sprite template from disk.
  csRef<iMeshFactoryWrapper> imeshfact (
    loader->LoadMeshObjectFactory ("/lib/std/sprite2"));
  if (imeshfact == 0)
    ReportError("Error loading mesh object factory!");

  // Create the sprite and add it to the engine.
  int userStartX = 29;
  int userStartY = 19;
  int userStartHeight = 1;
  csRef<iMeshWrapper> sprite4 (engine->CreateMeshWrapper (
    imeshfact, "Sprite4", room,
    csVector3 (userStartX, userStartHeight, userStartY)));

  csMatrix3 m; 
  m.Identity ();

  sprite4->GetMovable ()->SetTransform (m);
  sprite4->GetMovable ()->UpdateMove ();
  csRef<iSprite3DState> spstate( 
    SCF_QUERY_INTERFACE (sprite4->GetMeshObject (), iSprite3DState));
  spstate->SetAction ("default");

  user = sprite4;

  userView->GetCamera ()->SetSector (room);
  userView->GetCamera ()->GetTransform ().SetOrigin (csVector3 (userStartX, 
    userStartHeight, userStartY));
}

void Simple::createAgent() {
  movingAgent = false;

  // Load a texture for our sprite.
  iTextureWrapper* txt = loader->LoadTexture ("gray",
    "/lib/std/spark.png");
  if (txt == 0)
    ReportError("Error loading texture!");

  // Load a sprite template from disk.
  csRef<iMeshFactoryWrapper> imeshfact (
    loader->LoadMeshObjectFactory ("/lib/std/sprite1"));
  if (imeshfact == 0)
    ReportError("Error loading mesh object factory!");

  int agentStartX = 21;
  int agentStartY = 15;
  int agentStartHeight = 3;
  // Create the sprite and add it to the engine.
  csRef<iMeshWrapper> sprite3 (engine->CreateMeshWrapper (
    imeshfact, "Sprite3", room,
    csVector3 (agentStartX, agentStartHeight, agentStartY)));

  csMatrix3 m; 
  m.Identity ();

  sprite3->GetMovable ()->SetTransform (m);
  sprite3->GetMovable ()->UpdateMove ();
  csRef<iSprite3DState> spstate( 
    SCF_QUERY_INTERFACE (sprite3->GetMeshObject (), iSprite3DState));
  spstate->SetAction ("default");

  agent = sprite3;

  // Now we need to position the camera in our world.
  agentView->GetCamera ()->SetSector (room);
  agentView->GetCamera ()->GetTransform ().SetOrigin 
    (csVector3 (agentStartX, agentStartHeight, agentStartY));

  iCamera* agentCamera = agentView->GetCamera();
  csMatrix3 rot = csXRotMatrix3 (agentRotX) * csYRotMatrix3 (agentRotY);
  csOrthoTransform ot (rot, agentCamera->GetTransform().GetOrigin ());
  agentCamera->SetTransform (ot);
  agent->GetMovable()->SetTransform(ot);
  agent->GetMovable()->UpdateMove();

}

void Simple::FinishFrame ()
{
  // Just tell the 3D renderer that everything has been rendered.
  g3d->FinishDraw ();
  g3d->Print (0);
}

bool Simple::OnKeyboard(iEvent& ev)
{
  // We got a keyboard event.
  csKeyEventType eventtype = csKeyEventHelper::GetEventType(&ev);
  if (eventtype == csKeyEventTypeDown)
  {
    // The user pressed a key (as opposed to releasing it).
    utf32_char code = csKeyEventHelper::GetCookedCode(&ev);
    if (code == CSKEY_ESC)
    {
      // The user pressed escape to exit the application.
      // The proper way to quit a Crystal Space application
      // is by broadcasting a csevQuit event. That will cause the
      // main runloop to stop. To do that we get the event queue from
      // the object registry and then post the event.
      csRef<iEventQueue> q = 
        CS_QUERY_REGISTRY(GetObjectRegistry(), iEventQueue);
      if (q.IsValid()) q->GetEventOutlet()->Broadcast(csevQuit(GetObjectRegistry()));
    }
  }
  return false;
}

//bool Simple::OnInitialize(int argc, char* argv [])
bool Simple::OnInitialize(int, char*  [])
{
  // RequestPlugins() will load all plugins we specify. In addition
  // it will also check if there are plugins that need to be loaded
  // from the config system (both the application config and CS or
  // global configs). In addition it also supports specifying plugins
  // on the commandline.
  if (!csInitializer::RequestPlugins(GetObjectRegistry(),
    CS_REQUEST_VFS,
    CS_REQUEST_OPENGL3D,
    CS_REQUEST_ENGINE,
    CS_REQUEST_FONTSERVER,
    CS_REQUEST_IMAGELOADER,
    CS_REQUEST_LEVELLOADER,
    CS_REQUEST_REPORTER,
    CS_REQUEST_REPORTERLISTENER,
    CS_REQUEST_END))
    return ReportError("Failed to initialize plugins!");

  csBaseEventHandler::Initialize(GetObjectRegistry());

  // Now we need to setup an event handler for our application.
  // Crystal Space is fully event-driven. Everything (except for this
  // initialization) happens in an event.
  if (!RegisterQueue(GetObjectRegistry(), csevAllEvents(GetObjectRegistry())))
    return ReportError("Failed to set up event handler!");

  return true;
}

void Simple::OnExit()
{
}

bool Simple::Application()
{
  // Open the main system. This will open all the previously loaded plug-ins.
  // i.e. all windows will be opened.
  if (!OpenApplication(GetObjectRegistry()))
    return ReportError("Error opening system!");

  if (SetupModules()) {
    // This calls the default runloop. This will basically just keep
    // broadcasting process events to keep the game going.
    Run();
  }
  return true;
}

bool Simple::SetupModules()
{
  // Now get the pointer to various modules we need. We fetch them
  // from the object registry. The RequestPlugins() call we did earlier
  // registered all loaded plugins with the object registry.
  // The virtual clock.
  g3d = CS_QUERY_REGISTRY(GetObjectRegistry(), iGraphics3D);
  if (!g3d) return ReportError("Failed to locate 3D renderer!");

  engine = CS_QUERY_REGISTRY(GetObjectRegistry(), iEngine);
  if (!engine) return ReportError("Failed to locate 3D engine!");

  vc = CS_QUERY_REGISTRY(GetObjectRegistry(), iVirtualClock);
  if (!vc) return ReportError("Failed to locate Virtual Clock!");

  kbd = CS_QUERY_REGISTRY(GetObjectRegistry(), iKeyboardDriver);
  if (!kbd) return ReportError("Failed to locate Keyboard Driver!");

  loader = CS_QUERY_REGISTRY(GetObjectRegistry(), iLoader);
  if (!loader) return ReportError("Failed to locate Loader!");

  // We need a View to the virtual world.
  userView.AttachNew(new csView (engine, g3d));
  agentView.AttachNew(new csView (engine, g3d));
  iGraphics2D* g2d = g3d->GetDriver2D ();
  // We use the full window to draw the world.
  //userView->SetRectangle (0, 0, (g2d->GetWidth ())/2, g2d->GetHeight ());
  //agentView->SetRectangle ((g2d->GetWidth ())/2, 0, g2d->GetWidth (), g2d->GetHeight ());  
  userView->SetRectangle (0, 0, g2d->GetWidth (), g2d->GetHeight ());
  agentView->SetRectangle (0, 0, g2d->GetWidth (), g2d->GetHeight ());

  // First disable the lighting cache. Our app is simple enough
  // not to need this.
  engine->SetLightingCacheMode (0);
  
  csColor ambLightColor(0.2,0.2,0.2);
  engine->SetAmbientLight(ambLightColor);

  // Here we create our world.
  CreateRoom();

  // Here we create our world.
  CreateSprites();

  // these are used store the current orientation of the cameras
  userRotY = 4.5;
  userRotX = 0; //ignored
  agentRotY = 4.45;
  agentRotX = 0; //ignored

  createAgent();
  createUser();

  // Let the engine prepare all lightmaps for use and also free all images 
  // that were loaded for the texture manager.
  engine->Prepare ();


  return true;
}


void Simple::CreateRoom ()
{
  // Load the texture from the standard library.  This is located in
  // CS/data/standard.zip and mounted as /lib/std using the Virtual
  // File System (VFS) plugin.
  if (!loader->LoadTexture ("stone", "/lib/std/white.gif"))
    ReportError("Error loading 'white' texture!");

  iMaterialWrapper* tm = engine->GetMaterialList ()->FindByName ("stone");

  // We create a new sector called "room".
  room = engine->CreateSector ("room");

  // Creating the walls for our room.
  csRef<iMeshWrapper> walls (engine->CreateSectorWallsMesh (room, "walls"));
  csRef<iThingFactoryState> walls_state = 
    scfQueryInterface<iThingFactoryState> (walls->GetMeshObject ()->GetFactory());
  //crh originalwalls_state->AddInsideBox (csVector3 (-5, 0, -5), csVector3 (5, 20, 5));
  walls_state->AddInsideBox (csVector3 (0, 0, 0), csVector3 (30, 10, 40));
  walls_state->SetPolygonMaterial (CS_POLYRANGE_LAST, tm);
  walls_state->SetPolygonTextureMapping (CS_POLYRANGE_LAST, 3);

  // Now we need light to see something.
  csRef<iLight> light;
  iLightList* ll = room->GetLights ();

  int ht=5;

  light = engine->CreateLight(0, csVector3(5, ht, 5), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(15, ht, 5), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(25, ht, 5), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(5, ht, 15), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(15, ht, 15), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(25, ht, 15), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(5, ht, 25), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(15, ht, 25), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(25, ht, 25), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(5, ht, 35), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(15, ht, 35), 10, csColor(1, 1, 1));
  ll->Add (light);
  light = engine->CreateLight(0, csVector3(25, ht, 35), 10, csColor(1, 1, 1));
  ll->Add (light);
}

void Simple::CreateSprites ()
{
  // Load a texture for our sprite.
  iTextureWrapper* txt = loader->LoadTexture ("spark",
    //"/lib/std/spark.png");
    "/lib/std/spark.png");
  if (txt == 0)
    ReportError("Error loading texture!");


  // Load a sprite template from disk.
  csRef<iMeshFactoryWrapper> imeshfact (
    //loader->LoadMeshObjectFactory ("/cygdrive/k/progs/CS/apps/tutorial/simple2/sprite1"));
    loader->LoadMeshObjectFactory ("/lib/std/chrisstalagmite"));
  //loader->LoadMeshObjectFactory ("/lib/std/chrispyramid"));
  if (imeshfact == 0)
    ReportError("Error loading mesh object factory!");

  // Create the sprite and add it to the engine.

  csRef<iMeshWrapper> sprite (engine->CreateMeshWrapper (
    imeshfact, "MySprite", room,
    //csVector3 (15, 20, 7)));  //put it above the room
    //csVector3 (15, 7, 7)));
    csVector3 (10, 3, 10)));
  csMatrix3 m; m.Identity ();
  sprite->GetMovable ()->SetTransform (m);
  sprite->GetMovable ()->UpdateMove ();
  csRef<iSprite3DState> spstate (
    SCF_QUERY_INTERFACE (sprite->GetMeshObject (), iSprite3DState));
  spstate->SetAction ("default");
  //spstate->SetMixMode (CS_FX_SETALPHA (.5));

  // The following two calls are not needed since CS_ZBUF_USE and
  // Object render priority are the default but they show how you
  // can do this.
  sprite->SetZBufMode (CS_ZBUF_USE);
  sprite->SetRenderPriority (engine->GetObjectRenderPriority ());


  //crh create a second sprite
  // Load a sprite template from disk.
  csRef<iMeshFactoryWrapper> imeshfact2 (
   //CRHZ this is the one to change to get a pyramid/stalactite in the scence
   //loader->LoadMeshObjectFactory ("/lib/std/chrisstalagmite"));
   loader->LoadMeshObjectFactory ("/lib/std/chrispyramid"));
  if (imeshfact2 == 0)
    ReportError("Error loading mesh object factory!");

  //CRHZ this is the one to change to move it left or right
  // Create the sprite and add it to the engine
   csRef<iMeshWrapper> sprite2 (engine->CreateMeshWrapper (
    imeshfact2, "MySprite2", room,
    csVector3 (10, 2.8, 4))); //left
    // csVector3 (10, 3, 8))); //centre
    //csVector3 (10, 3, 12))); //right
    //csVector3 (10, 20, 8))); //off
  sprite2->GetMovable ()->SetTransform (m);
  sprite2->GetMovable ()->UpdateMove ();
  csRef<iSprite3DState> sp2state (
    SCF_QUERY_INTERFACE (sprite2->GetMeshObject (), iSprite3DState));
  sp2state->SetAction ("default");
  
  //spstate->SetMixMode (CS_FX_SETALPHA (.5));

  // The following two calls are not needed since CS_ZBUF_USE and
  // Object render priority are the default but they show how you
  // can do this.
  //sprite2->SetZBufMode (CS_ZBUF_USE);
  //sprite2->SetRenderPriority (engine->GetObjectRenderPriority ());
}

//-------------------------------------------------------------------------*
// Main function
//-------------------------------------------------------------------------
int main (int argc, char* argv[])
{
  /* Runs the application. 
   *
   * csApplicationRunner<> is a small wrapper to support "restartable" 
   * applications (ie where CS needs to be completely shut down and loaded 
   * again). Simple1 does not use that functionality itself, however, it
   * allows you to later use "Simple.Restart();" and it'll just work.
   */
  return csApplicationRunner<Simple>::Run (argc, argv);
}
